let offline = true;
let surl = '../prj/pv.php';

let fileHandle = null;

let authid = "000000"
let projname = "";
let filename = "";

//let masterid = "";

var qrcode;

let settings = [];

//let kimodal = null;
//let kisettingsmodal = null;

function showAbordDialog(e) {
    if (authid == "000000") {
        preventDefault();
    }
    var confirmationMessage = 'abord2';
    (e || window.event).returnValue = confirmationMessage;
    return confirmationMessage;
}

window.addEventListener("beforeunload", function (e) {
    //console.log("EventListener added");
    return showAbordDialog(e);
});


window.addEventListener('load', () => {

    var splashScreen = document.querySelector('.splash');
    splashScreen.addEventListener('click', () => {
        splashScreen.style.opacity = 0;
        setTimeout(() => {
            splashScreen.classList.add('splashhidden')
            document.querySelector('#thesite').style.opacity = 1.0;
            document.querySelector('#thesite').style.filter = "none";
            document.querySelectorAll('.winbox').forEach((item) => {
                item.style.opacity = 1.0;
                item.style.filter = "none";
            })
        }, 610)
    })

    document.querySelector('#mi_view_projectsoverviewwindow').style.display = 'none';
    document.querySelector('#navbarAccountMenuLinkId').style.display = 'none';

    qrcode = new QRCode("qrcode", "")

    if (offline) {
        surl = "";
        document.querySelectorAll('.onlineonly').forEach((elem) => {
            elem.style.visibility = 'hidden';
            elem.style.width = 0;
            elem.style.height = 0;
        })
        win_programming.body.firstChild.contentWindow.postMessage({
            type: 'offline',
            data: {
                offline: true
            },
            option: {
            }
        }, '*');
    }




    window.addEventListener("message", (event) => {
        //console.log(event);
        if (event.data.type == 'logmsg') {
            log(event.data.data);
        } else if (event.data.type == 'logout') {
            logout();
        } else if (event.data.type == 'loginchanged') {
            notifyNewLoginName(event.data.data);
        } else if (event.data.type == 'htmlmodified') {
            win_gui.body.firstChild.contentWindow.postMessage(event.data, '*');
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'cssmodified') {
            win_gui.body.firstChild.contentWindow.postMessage(event.data, '*');
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'run') {
            win_gui.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'run2') {
            win_gui.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'tsmodified') {
            win_struktogrammer.body.firstChild.contentWindow.postMessage(event.data, '*');
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'tsAllmodified') {
            win_struktogrammer.body.firstChild.contentWindow.postMessage(event.data, '*');
            win_classdiagram.body.firstChild.contentWindow.postMessage(event.data, '*');
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'guireloadrequest') {
            window.setTimeout(() => {
                win_programming.body.firstChild.contentWindow.postMessage(event.data, '*');
            }, 1000)
            win_errorlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'markerupdate') {
            win_errorlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'savecloudproject') {
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'savecloudprojectForce') {
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'copycloudproject') {
            event.data.filename = filename;
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'saveproject') {
            saveProject(event.data.data);
        } else if (event.data.type == 'loadproject') {
            loadProject(event.data.data);
        } else if (event.data.type == 'newcloudproject') {
            newCloudProject(event.data.data);
        } else if (event.data.type == 'loadcloudproject') {
            loadCloudProject(event.data.data.prjid, event.data.data.authid);
        } else if (event.data.type == 'setstatusrequest') {
            setStatus(event.data.data.prjid, event.data.data.authid, event.data.data.status);
        } else if (event.data.type == 'renamerequest') {
            showModalRenamDialog(event.data.data.name1);
        } else if (event.data.type == 'newprojectnamerequest') {
            notifyNewProjectName(event.data.data);
        } else if (event.data.type == 'editorcontentrequest') {
            win_programming.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'editorcontent') {
            win_projectlist.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'cleareditor') {
            win_programming.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'clearlog') {
            win_console.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'log') {
            win_console.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'modalsettings') {
            showModalSettingsDialog(event.data.data);
        } else if (event.data.type == 'modalinfo') {
            showModalInfo(event.data.data.txt, event.data.data.error);
        } else if (event.data.type == 'modalinfoqr') {
            showModalInfoqr(event.data.data.txt, event.data.data.code, event.data.data.error);
        } else if (event.data.type == 'highlightrangerequest') {
            win_programming.body.firstChild.contentWindow.postMessage(event.data, '*');
        } else if (event.data.type == 'openstorerequest') {
            showModalStoreDialog(event.data.data);
        } else if (event.data.type == 'addtostore') {
            showModalAddToStoreDialog(event.data.data);
        } else if (event.data.type == 'kisettingsrequest') {
            showModalKISettingsDialog(event.data.data);
        } else if (event.data.type == 'kirequest') {
            showModalKIDialog(event.data.data, event.data.code);
        } else {
            //console.log(event.data.type);
            //console.log(event);
            //alert(event);
        }
    }, false);


    document.querySelector("#mi_view_fullscreen, #mi_view_fullscreen_status").addEventListener('click', (event) => {
        let element = document.body;

        let fullscreen = document.querySelector("#mi_view_fullscreen_status").checked;

        if (event.target.id == "mi_view_fullscreen_status") {
            fullscreen = !document.querySelector("#mi_view_fullscreen_status").checked;
        }

        if (!fullscreen) {
            element.requestFullscreen()
                .then(function () {
                    document.querySelector("#mi_view_fullscreen_status").checked = true;
                })
                .catch(function (error) {
                    document.querySelector("#mi_view_fullscreen_status").checked = false;
                });
        } else {
            document.exitFullscreen()
                .then(function () {
                    document.querySelector("#mi_view_fullscreen_status").checked = false;
                })
                .catch(function (error) {
                    document.querySelector("#mi_view_fullscreen_status").checked = false;
                });

        }
    })

    document.querySelector("#mi_view_minimizeall").addEventListener('click', (event) => {
        win_programming.minimize();
        win_gui.minimize();
        win_console.minimize();
        win_errorlist.minimize();
        win_projectlist.minimize();
        win_projectoverview.minimize();
        win_classdiagram.minimize();
        win_struktogrammer.minimize();
    })

    document.querySelector("#mi_view_programmingwindow").addEventListener('click', (event) => {
        document.querySelector('#programming').style.visibility = 'visible'
        win_programming.focus()
    })

    document.querySelector("#mi_view_guiwindow").addEventListener('click', (event) => {
        document.querySelector('#gui').style.visibility = 'visible'
        win_gui.focus()
    })

    document.querySelector("#mi_view_consolewindow").addEventListener('click', (event) => {
        document.querySelector('#console').style.visibility = 'visible'
        win_console.focus()
    })

    document.querySelector("#mi_view_projectswindow").addEventListener('click', (event) => {
        document.querySelector('#projectlist').style.visibility = 'visible'
        win_projectlist.focus()
    })

    document.querySelector("#mi_view_projectsoverviewwindow").addEventListener('click', (event) => {
        document.querySelector('#projectoverview').style.visibility = 'visible'
        win_projectoverview.focus()
    })

    document.querySelector("#mi_view_errorlistwindow").addEventListener('click', (event) => {
        document.querySelector('#errorlist').style.visibility = 'visible'
        win_errorlist.focus()
    })

    document.querySelector("#mi_view_classdiagramwindow").addEventListener('click', (event) => {
        document.querySelector('#classdiagram').style.visibility = 'visible'
        win_classdiagram.focus()
    })

    document.querySelector("#mi_view_struktogrammerwindow").addEventListener('click', (event) => {
        document.querySelector('#struktogrammer').style.visibility = 'visible'
        win_classdiagram.focus()
    })


    document.querySelector('#mi_login').addEventListener('click', (event) => {
        if (document.querySelector('#mi_login').innerHTML == "Login") {
            let modal = new bootstrap.Modal(document.querySelector('#loginModal'))
            modal.show();
        } else {
            logout();
        }
    })

    document.querySelector('#loginname').addEventListener('keypress', async (event) => {
        if (event.key === "Enter") {
            event.preventDefault();
            document.querySelector("#btnLogin").click();
        }
    })

    document.querySelector('#btnLogin').addEventListener('click', async (event) => {
        if (document.querySelector('#loginname').value.trim().length > 0) {
            authid = document.querySelector('#loginname').value.trim();
            document.querySelector('#loginname').value = '';


            let formData = new FormData();
            formData.append('cmd', 'login');
            formData.append('authid', authid);

            try {
                const response = await fetch(surl, {
                    method: "POST",
                    body: formData
                });
                if (!response.ok) {
                    throw new Error(`Response status: ${response.status}`);
                }

                //get settings
                const json = await response.json();
                if (json == "ok") {
                    try {
                        let formData2 = new FormData();
                        formData2.append('cmd', 'getsettings');
                        formData2.append('magicnumber', authid);

                        const response2 = await fetch(url, {
                            method: "POST",
                            body: formData2
                        });
                        if (!response2.ok) {
                            throw new Error(`Response status: ${response2.status}`);
                        }

                        //get settings
                        const settings = await response2.json();
                        notifyNewSettings(settings);

                    } catch (error2) {
                        console.error(error2.message);
                    }
                }


                notifyNewLoginName(authid);
                notifyNewProjectName('');
                if (authid.length >= 8) {
                    document.querySelector('#mi_view_projectsoverviewwindow').style.display = 'block';
                }
                if (authid.length > 8) {
                    document.querySelector('#navbarAccountMenuLinkId').style.display = 'block';
                }

            } catch (error) {
                console.error(error.message);
            }
        }
    })



    document.querySelector("#mi_view_account").addEventListener('click', (event) => {
        openAdminAccountDialog();
    })

    document.querySelector("#mi_view_admintokens").addEventListener('click', (event) => {
        openAdminTokenDialog();
    })

    document.querySelector("#mi_view_adminsettings").addEventListener('click', (event) => {
        openAdminSettingsDialog();
    })

    document.querySelector("#mi_view_adminlogs").addEventListener('click', (event) => {
        openAdminLogsDialog();
    })


    document.querySelectorAll('[id^="settingitem_"').forEach((sitem) => {
        sitem.addEventListener('click', async () => {
            let formData = new FormData();
            formData.append('cmd', 'setsettings');
            formData.append('magicnumber', authid);
            formData.append('freeKI', document.querySelector('#settingitem_swFreeKI').checked);

            try {
                const response = await fetch(surl, {
                    method: "POST",
                    body: formData
                });
                if (!response.ok) {
                    throw new Error(`Response status: ${response.status}`);
                }

                const json = await response.json();
                //console.log(json);

                notifyNewSettings(json);


            } catch (ex) {
                console.log(ex);
            }
        })
    })


    document.querySelector('#destroyAccount').addEventListener('click', async () => {
        let formData = new FormData();
        formData.append('cmd', 'destroyAccount');
        formData.append('magicnumber', document.querySelector('#destroyAuthId').value);

        try {
            const response = await fetch(surl, {
                method: "POST",
                body: formData
            });
            if (!response.ok) {
                throw new Error(`Response status: ${response.status}`);
            }

            const json = await response.json();


            if (json.length <= 2) {
                projname = "";
                authid = "000000"
                filename = "";

                notifyNewLoginName(authid);

                location.reload();
            } else {
                showModalInfo("Fehler beim Löschen des Accounts!", json);
            }


        } catch (ex) {
            console.log(ex);
        }

    })


    document.querySelector('#btnNewProject').addEventListener('click', (event) => {
        let pname = document.querySelector('#projectname').value;
        document.querySelector('#projectname').value = "";
        if (pname.length > 0) {
            if (!pname.endsWith('.tmyts') && !pname.endsWith('.store')) {
                pname = pname + '.tmyts';
            }
            win_projectlist.body.firstChild.contentWindow.postMessage({
                type: 'newproject',
                data: pname
            }, '*');
            win_programming.body.firstChild.contentWindow.postMessage({
                type: 'newproject',
                data: pname
            }, '*');
        }
    })

    document.querySelector('#btnRename').addEventListener('click', (event) => {
        let pnameOld = document.querySelector('#renameModal #projectname').value;
        let pnameNew = document.querySelector('#renameModal #projectnameoriginal').value;
        if (pnameNew.length > 0) {
            if (!pnameNew.endsWith('.tmyts') && !pnameNew.endsWith('.store')) {
                pnameNew = pnameNew + '.tmyts';
            }
            win_projectlist.body.firstChild.contentWindow.postMessage({
                type: 'renameproject',
                data: {
                    pnameOld: pnameOld,
                    pnameNew: pnameNew
                }
            }, '*');
        }
    })

    document.querySelector('#btnSettings').addEventListener('click', (event) => {
        let jsmode = document.querySelector('#modalSettingsDialog #jsmode').checked;
        //console.log(jsmode)
        /*
        if (pnameNew.length > 0) {
            if (!pnameNew.endsWith('.tmyts')) {
                pnameNew = pnameNew + '.tmyts';
            }
            win_projectlist.body.firstChild.contentWindow.postMessage({
                type: 'renameproject',
                data: {
                    pnameOld: pnameOld,
                    pnameNew: pnameNew
                }
            }, '*');
        }*/
    })

    document.querySelector('#btnKIRequest').addEventListener('click', async (event) => {
        document.querySelector('#modalkiDialog .modal-body #ki_answer').innerHTML = "";
        document.querySelector('#modalkiDialog .modal-body #ki_modell').innerHTML = "";
        document.querySelector('#ki_spinner').style.display = "block";

        var blob = new Blob([`<html><head></head><body>&nbsp;</body></html>`], { type: "text/html; charset=utf-8" });
        const iframe = document.querySelector('#ki_answeri');
        iframe.src = URL.createObjectURL(blob);


        //masterid = document.querySelector('#ki_masterid').value;

        if (document.querySelector('#ki_editable').value == "true") {
            document.querySelector('#ki_textuser').value = document.querySelector('#ki_userquestion').value;
            document.querySelector('#ki_addcode').value = document.querySelector('#ki_userquestionaddcode').checked ? true : false;
        }

        let textuser = document.querySelector('#ki_textuser').value;
        if (document.querySelector('#ki_addcode') && document.querySelector('#ki_addcode').value == "true") {
            textuser += "\n\nDer Code: " + document.querySelector('#ki_code').value;
        }


        let formData = new FormData();
        formData.append('cmd', 'ki');
        formData.append('masterid', authid);
        formData.append('prjid', projname);
        formData.append('token', document.querySelector('#ki_token').value);
        formData.append('textsystem', "Formatiere und strukturiere die Antwort als Text. Nehme die Rolle eines Lehrers ein. Die Antwort ist für Anfänger bestimmt.");//document.querySelector('#ki_textsystem').value);
        formData.append('textuser', textuser);

        try {
            const response = await fetch(surl, {
                method: "POST",
                body: formData
            });
            if (!response.ok) {
                throw new Error(`Response status: ${response.status}`);
            }

            const json = await response.json();

            document.querySelector('#ki_spinner').style.display = "none";
            //console.log(json);

            document.querySelector('#ki_token').value = "";

            var converter = new showdown.Converter(),
                html = converter.makeHtml(json.answer);
            let answer = html;

            if (document.querySelector('#ki_replaceenitites') && document.querySelector('#ki_replaceenitites').value == "true") {
                //answer = answer.replaceAll("<", "&lt;").replaceAll(">", "&gt;").replaceAll("\n", "<br>")
            }

            //console.info(answer);

            //document.querySelector('#modalkiDialog .modal-body #ki_answer').innerHTML = answer;
            document.querySelector('#modalkiDialog .modal-body #ki_modell').innerHTML = json.modell;

            var blob = new Blob([answer], { type: "text/html; charset=utf-8" });
            const iframe = document.querySelector('#ki_answeri');
            iframe.src = URL.createObjectURL(blob);

        } catch (error) {
            console.error(error.message);
        }
    })


    document.querySelector('#btnKISettingsRequest').addEventListener('click', el => {
        let data = JSON.parse(document.querySelector('#btnKISettingsRequest').getAttribute('data-data'));

        let pos = document.querySelector('#kistettingstoolbar').getAttribute('data-pos');

        data[pos - 1].menutitle = document.querySelector('#kistettingscontent #menutitle').value;
        data[pos - 1].textsystem = document.querySelector('#kistettingscontent #systemtext').value;
        data[pos - 1].textuser = document.querySelector('#kistettingscontent #usertext').value;
        data[pos - 1].addcode = document.querySelector('#kistettingscontent #addcode').checked;
        data[pos - 1].replaceenitites = document.querySelector('#kistettingscontent #replaceenitites').checked;

        win_programming.body.firstChild.contentWindow.postMessage({
            type: 'kisettingsresponse',
            data: data
        }, '*')

        document.querySelector('#btnKISettingsRequest').setAttribute('data-data', "{}");
        kisettingsmodal.hide();
        //kisettingsmodal.dispose();
    })




    document.querySelector('#kistettingstoolbar .bi-trash').addEventListener('click', el => {
        let data = JSON.parse(document.querySelector('#btnKISettingsRequest').getAttribute('data-data'));
        let pos = document.querySelector('#kistettingstoolbar').getAttribute('data-pos');

        data.splice(pos - 1, 1);
        showModalKISettingsDialog(data);
    })



    document.querySelector('#generatetokenbtn').addEventListener('click', async () => {
        document.querySelector('#modalAdminTokensDialog .nav-link.active').classList.remove('active');
        document.querySelector('#generatetokenbtn').classList.add('active');

        let html = "<p>&nbsp;</p>";

        html += '<div class="form-floating m-3">';
        html += '<select id="flType" class="form-select" aria-label="" style="width: 280px;">';
        html += '    <option value="standard" selected>Standard</option>';
        html += '    <option value="3er">3er-Token</option>';
        html += '    <option value="5er">5er-Token</option>';
        html += '    <option value="10er">10er-Token</option>';
        html += '</select>';
        html += '<label for="flType">Typ</label>';
        html += '</div>';

        html += '<div style="display: flex;">';

        html += '<div class="form-floating m-3"  style="width: 280px;">';
        html += '<input class="form-control" id="fiCount" placeholder="" type="number" min="1" max="1000" step="1" value="30">';
        html += '<label for="fiCount">Anzahl</label>';
        html += '</div>';

        html += '<div class="form-floating m-3" style="width: 280px;">';
        html += '<input class="form-control" id="fiExpires" placeholder="" type="number" min="1" max="365" value="90">';
        html += '<label for="fiExpires">Gültigkeit in Tagen</label>';
        html += '</div>';

        html += '</div>';

        html += '<button class="btn btn-light m-3" id="generatetokengobtn">Tokens erzeugen</button>';

        document.querySelector('#admintokendialogcontent').innerHTML = html;

        document.querySelector('#generatetokengobtn').addEventListener('click', async () => {
            let formData = new FormData();
            formData.append('cmd', 'createTokens');
            formData.append('count', document.querySelector('#admintokendialogcontent #fiCount').value);
            formData.append('expires', document.querySelector('#admintokendialogcontent #fiExpires').value);
            formData.append('type', document.querySelector('#admintokendialogcontent #flType').value);
            formData.append('magicnumber', authid);


            try {
                const response = await fetch(surl, {
                    method: "POST",
                    body: formData
                });
                if (!response.ok) {
                    throw new Error(`Response status: ${response.status}`);
                }

                const json = await response.json();

                showModalInfo('Erstellung der Tokens erfolgreich beendet!', 'Es wurden ' + json.tokens.length + " neu Tokens erstellt");

            } catch (error) {
                console.error(error.message);
            }
        })
    })


    document.querySelector('#showtokenbtn').addEventListener('click', async () => {

        document.querySelector('#modalAdminTokensDialog .nav-link.active').classList.remove('active');
        document.querySelector('#showtokenbtn').classList.add('active');

        let formData = new FormData();
        formData.append('cmd', 'getTokens');
        formData.append('authid', authid);

        try {
            const response = await fetch(surl, {
                method: "POST",
                body: formData
            });
            if (!response.ok) {
                throw new Error(`Response status: ${response.status}`);
            }


            const json = await response.json();
            //console.log(json);

            let html = "";

            html += "<p class='m-3'>Anzahl der verfügbaren Tokens: " + json.tokens.length + ' <button class="btn btn-light btn-sm m-3" id="printtokenbtn">Tokens drucken</button></p>';

            html += "<table class='table table-striped table-hover table-bordered table-sm'>";
            html += "<tr>";
            html += '<thead class="table-dark"></thead>';
            html += "<th>Token</th>";
            html += "<th>Typ</th>";
            html += "<th>Gültig bis</th>";
            html += "<th>Info</th>";
            html += "<th>Erstellt am</th>";
            html += '</thead>';
            html += '<body>';
            html += "</tr>";
            json.tokens.map(token => {
                html += "<tr>";
                html += "<td>" + token.token + "</td>";
                html += "<td>" + token.type + "</td>";
                html += "<td>" + token.expires + "</td>";
                html += "<td>" + (typeof token.info == 'undefined' ? '-' : token.info) + "</td>";
                html += "<td>" + token.created + "</td>";
                html += "</tr>";
            })
            html += '</body>';
            html += "</table>";

            html += '<p class="m-3"><button class="btn btn-danger btn-sm m-3" id="destroytokenbtn">Alle Tokens löschen</button></p>';

            document.querySelector('#admintokendialogcontent').innerHTML = html;

            document.querySelector('#printtokenbtn').addEventListener('click', async () => {
                fetch(surl + '?cmd=pdftokens&authid=' + authid)
                    .then(res => {
                        //you may want to add some validation here
                        downloadFile("tokens.pdf", res);
                    })
                    .catch(function (error) {
                        console.log(error);
                    })
            })

            document.querySelector('#destroytokenbtn').addEventListener('click', async () => {
                let formData = new FormData();
                formData.append('cmd', 'destroytoken');
                formData.append('magicnumber', authid);

                try {
                    const response = await fetch(surl, {
                        method: "POST",
                        body: formData
                    });
                    if (!response.ok) {
                        throw new Error(`Response status: ${response.status}`);
                    }

                    const json = await response.json();
                    //console.log(json);

                    document.querySelector('#showtokenbtn').click();

                    showModalInfo("", json);

                } catch (error) {
                    console.error(error.message);
                }

            })

        } catch (error) {
            console.error(error.message);
        }
    });


    document.querySelector('#tokenstatisticbtn').addEventListener('click', async () => {

        document.querySelector('#modalAdminTokensDialog .nav-link.active').classList.remove('active');
        document.querySelector('#tokenstatisticbtn').classList.add('active');

        let html = "";
        html += '<canvas style="margin: 48px auto;" id="chart1"></canvas>';
        html += '<canvas style="margin: 48px auto;" id="chart2"></canvas>';
        html += '<p class="m-3"><button class="btn btn-danger btn-sm m-3" id="destroyTokenLogbtn">Statistik zurücksetzen</button></p>';

        document.querySelector('#admintokendialogcontent').innerHTML = html;

        document.querySelector('#destroyTokenLogbtn').addEventListener('click', async () => {
            let formData = new FormData();
            formData.append('cmd', 'destroytokenlog');
            formData.append('magicnumber', authid);

            try {
                const response = await fetch(surl, {
                    method: "POST",
                    body: formData
                });
                if (!response.ok) {
                    throw new Error(`Response status: ${response.status}`);
                }

                const json = await response.json();
                //console.log(json);

                document.querySelector('#tokenstatisticbtn').click();

                showModalInfo("", json);

            } catch (error) {
                console.error(error.message);
            }

        })


        let formData = new FormData();
        formData.append('cmd', 'getTokenUsing');
        formData.append('magicnumber', authid);

        try {
            const response = await fetch(surl, {
                method: "POST",
                body: formData
            });
            if (!response.ok) {
                throw new Error(`Response status: ${response.status}`);
            }

            let txt = await response.text();

            const data = [];
            datarow = txt.split("\n");
            console.log(data);
            datarow.map(row => {
                data.push(row.split(";"));
            })
            console.log(data);

            if (data.length > 0 && data[0].length >= 4) {

                const userdata = [];
                data.map(ds => {
                    if (ds.length >= 4) {
                        const name = ds[2];
                        if (typeof userdata[name] === "undefined") {
                            userdata[name] = 0;
                        }
                        userdata[name]++
                    }
                })

                const userkeys = Object.keys(userdata);
                const uservalues = userkeys.map(k => userdata[k]);

                new Chart(
                    document.getElementById('chart1'),
                    {
                        type: 'pie',
                        data: {
                            labels: userkeys,
                            datasets: [{
                                label: "Tokennutzung",
                                data: uservalues,
                            }]
                        },
                        options: {
                            plugins: {
                                legend: {
                                    display: false,
                                    position: 'bottom',
                                },
                                title: {
                                    display: true,
                                    text: "Tokennutzung nach Benutzer",
                                }
                            }
                        },
                    }
                );





                const prjdata = [];
                data.map(ds => {
                    if (ds.length >= 4) {
                        const prj = ds[3];
                        if (typeof prjdata[prj] === "undefined") {
                            prjdata[prj] = 0;
                        }
                        prjdata[prj]++
                    }
                })

                const prjkeys = Object.keys(prjdata);
                const prjvalues = prjkeys.map(k => prjdata[k]);

                new Chart(
                    document.getElementById('chart2'),
                    {
                        type: 'pie',
                        data: {
                            labels: prjkeys,
                            datasets: [{
                                label: "Tokennutzung",
                                data: prjvalues,
                            }]
                        },
                        options: {
                            plugins: {
                                legend: {
                                    display: false,
                                    position: 'bottom',
                                },
                                title: {
                                    display: true,
                                    text: "Tokennutzung nach Projekt",
                                }
                            }
                        },
                    }
                );

            } else {
                document.querySelector('#admintokendialogcontent').innerHTML = '<p class="m-3">Aktuell sind noch keine Tokens verwendet worden.</p>';
            }

        } catch (error) {
            console.error(error.message);
        }

    });


    document.querySelector('#btnStoreSearch').addEventListener('click', () => {
        updateStoreItemList();
    });

    document.querySelectorAll('.storeCat1').forEach((elem) => {
        elem.addEventListener('input', () => {
            fetchCat2(elem.value);
        });
    });


    document.querySelectorAll('#modalAddToStoreDialog .iconbar img').forEach((img) => {
        img.addEventListener('click', () => {
            document.querySelector('#addToStoreIcon').value = img.getAttribute("src");
        })
    })

    document.querySelector('#btnAddProjectToStore').addEventListener('click', async () => {
        let formData = new FormData();
        formData.append('cmd', 'addstoreproject');
        formData.append('authid', authid);
        formData.append('prjid', document.querySelector('.add2storeprjname').innerText);
        formData.append('cat1', document.querySelector('#addToStoreCat1').value);
        formData.append('cat2', document.querySelector('#addToStoreCat2').value);
        formData.append('cat2new', document.querySelector('#addToStoreNewCat2').value);
        formData.append('title', document.querySelector('#addToStoreTitle').value);
        formData.append('description', document.querySelector('#addToStoreDescription').value);
        formData.append('pseudonym', document.querySelector('#addToStorePseudonym').value);
        formData.append('keywords', document.querySelector('#addToStoreKeywords').value);
        if (document.querySelector('#addToStoreIcon').value.trim().length == 0) {
            formData.append('icon', "img/p0.png");
        } else {
            formData.append('icon', document.querySelector('#addToStoreIcon').value);
        }


        try {
            const response = await fetch(surl, {
                method: "POST",
                body: formData
            });
            if (!response.ok) {
                throw new Error(`Response status: ${response.status}`);
            }

            const json = await response.json();
            showModalInfo('', json);

            updateStoreItemList();

        } catch (error) {
            console.error(error.message);
        }

    })


    document.querySelector('#modalAdminLogDialogSearchFilter').addEventListener('input', () => {
        filterLogsDialogContent();
    })

    document.querySelector('#updateLogsBtn').addEventListener('click', () => {
        updateLogsDialogContent();
    })

    document.querySelector('#deleteLogsBtn').addEventListener('click', () => {
        deleteLogsDialogContent();
    })

})



let win_programming = new WinBox("Programmieren", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 10,
    y: 66,
    width: '48%',
    height: '70%',
    url: "programmingframe.html",
    id: "programming",
    onclose: function () {
        //this.minimize();
        document.querySelector('#programming').style.visibility = 'hidden'
        return true;        //closing is forbidden
    }
});


let win_gui = new WinBox("GUI", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: '51%',
    y: 66,
    width: '48%',
    height: '65%',
    url: "guiframe.html",
    id: "gui",
    onclose: function () {
        //this.minimize();
        document.querySelector('#gui').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    },
});


let win_console = new WinBox("Konsole", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 10,
    y: 'bottom',
    width: '49%',
    height: '20%',
    url: "consoleframe.html",
    id: "console",
    onclose: function () {
        //this.minimize();
        document.querySelector('#console').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});


let win_projectlist = new WinBox("Cloud-Projektliste - " + authid, {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 'center',
    y: 'center',
    width: 740,
    height: 300,
    url: "projects.html",
    id: "projectlist",
    class: [
        "no-max",
        "no-full",
    ],
    onclose: function () {
        //this.minimize();
        document.querySelector('#projectlist').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});
document.querySelector('#projectlist').style.visibility = offline ? 'hidden' : 'visible'


let win_projectoverview = new WinBox("Projektübersicht", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 'center',
    y: 'center',
    width: 800,
    height: 600,
    url: "projectoverviewframe.html",
    id: "projectoverview",
    onclose: function () {
        //this.minimize();
        document.querySelector('#projectoverview').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});

document.querySelector('#projectoverview').style.visibility = 'hidden'


let win_errorlist = new WinBox("Fehlerliste", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 'right',
    y: 'bottom',
    width: '49%',
    height: "25%",
    url: "errorlist.html",
    id: "errorlist",
    onclose: function () {
        //this.minimize();
        document.querySelector('#errorlist').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});


let win_classdiagram = new WinBox("Klassendiagramm", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 'center',
    y: 'center',
    width: '30%',
    height: 600,
    url: "classdiagram.html",
    id: "classdiagram",
    onclose: function () {
        //this.minimize();
        document.querySelector('#classdiagram').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});

document.querySelector('#classdiagram').style.visibility = 'hidden'


let win_struktogrammer = new WinBox("Struktogramm", {
    root: document.body,
    top: 56,
    right: 0,
    bottom: 0,
    left: 0,
    x: 'center',
    y: 'center',
    width: '30%',
    height: 600,
    url: "struktogrammer.html",
    id: "struktogrammer",
    onclose: function () {
        //this.minimize();
        document.querySelector('#struktogrammer').style.visibility = 'hidden'
        return true;        //closing is forbidden!
    }
});

document.querySelector('#struktogrammer').style.visibility = 'hidden'


async function log(msg) {
    let formData = new FormData();
    formData.append('cmd', 'log');
    formData.append('authid', authid);
    formData.append('msg', msg);

    try {
        const response = await fetch(surl, {
            method: "POST",
            body: formData
        });
        if (!response.ok) {
            throw new Error(`Response status: ${response.status}`);
        }
    } catch (error) {
        console.error(error.message);
    }
}


async function logout() {

    let formData = new FormData();
    formData.append('cmd', 'logout');
    formData.append('authid', authid);

    try {
        const response = await fetch(surl, {
            method: "POST",
            body: formData
        });
        if (!response.ok) {
            throw new Error(`Response status: ${response.status}`);
        }

        document.querySelector('#mi_login').innerHTML = "Login";

        projname = "";
        authid = "000000"
        filename = "";

        notifyNewLoginName(authid);

        location.reload();

    } catch (error) {
        console.error(error.message);
    }

}


async function getNewFileHandle() {
    const opts = {
        type: 'save-file',
        accepts: [{
            description: 'ThommyTS-Projekt',
            extensions: ['tmyts'],
            mimeTypes: ['text/json'],
        }],
    };
    const handle = await window.showSaveFilePicker(opts);
    return handle;
}

async function saveProject(data) {
    fileHandle = await getNewFileHandle();
    if (fileHandle == null) {
        fileHandle = await showSaveFilePicker();
    }
    var content = JSON.stringify(data);
    await writeFile(fileHandle, content);
}

async function writeFile(fileHandle, contents) {
    const writable = await fileHandle.createWritable();
    await writable.truncate(0);
    await writable.write(contents);
    await writable.close();
}

async function loadProject() {
    if (window.showOpenFilePicker) {
        [fileHandle] = await window.showOpenFilePicker();
        const file = await fileHandle.getFile();
        const contents = await file.text();
        filename = fileHandle.name;
        projname = "";
        notifyNewProjectName(projname);
        win_programming.body.firstChild.contentWindow.postMessage({
            type: 'projectloaded',
            data: JSON.parse(contents)
        }, '*')
    }
};

async function setStatus(prjid, theAuthid, status) {
    fetch(surl + '?cmd=setstatus&authid=' + theAuthid + "&prjid=" + prjid + "&status=" + status)
        .then(response => response.json()
        )
        .then(function (contents) {
            /*            
                        win_programming.body.firstChild.contentWindow.postMessage({
                            type: 'projectloaded',
                            data: contents
                        }, '*')
            */
        })
        .catch(function (error) {
            showModalInfo('<div class="error">Der Status konnte nicht gesetzt werden', error);
        })
};




function newCloudProject(data) {
    let modal = new bootstrap.Modal(document.querySelector('#newProjectModal'))
    modal.show();
}


function loadCloudProject(prjid, theAuthid) {
    fetch(surl + '?cmd=load&authid=' + theAuthid + "&prjid=" + prjid)
        .then(response => response.json()
        )
        .then(function (contents) {
            notifyNewProjectName(prjid);
            win_programming.body.firstChild.contentWindow.postMessage({
                type: 'projectloaded',
                data: contents
            }, '*')
        })
        .catch(function (error) {
            showModalInfo('<div class="error">Das Projekt konnte nicht geladen werden', error);
        })
};


function notifyNewProjectName(prjid) {
    projname = prjid;

    win_programming.setTitle("Programmieren - " + projname);
    win_gui.setTitle("GUI - " + projname);

    win_projectlist.body.firstChild.contentWindow.postMessage({
        type: 'projectnamechanged',
        data: prjid
    }, '*');
    win_programming.body.firstChild.contentWindow.postMessage({
        type: 'projectnamechanged',
        data: prjid
    }, '*');
    win_gui.body.firstChild.contentWindow.postMessage({
        type: 'projectnamechanged',
        data: prjid
    }, '*');
}

function notifyNewLoginName(aid) {
    authid = aid;

    document.querySelector('#mi_login').innerHTML = "Logout";

    win_projectlist.setTitle("Cloud-Projektliste - " + authid.substring(0, 3) + "...");

    win_projectlist.body.firstChild.contentWindow.postMessage({
        type: 'loginchanged',
        data: authid
    }, '*');
    win_projectoverview.body.firstChild.contentWindow.postMessage({
        type: 'loginchanged',
        data: authid
    }, '*');
    win_programming.body.firstChild.contentWindow.postMessage({
        type: 'loginchanged',
        data: authid
    }, '*');
}

function notifyNewSettings(theSettings) {

    settings = theSettings;

    //notify windows
    win_programming.body.firstChild.contentWindow.postMessage({
        type: 'settings',
        data: theSettings
    }, '*');
}



function fetchCat1(cat) {
    fetch(surl + '?cmd=catalogCat1')
        .then(response => response.json()
        )
        .then(function (contents) {
            document.querySelectorAll('.storeCat1').forEach(elem => {
                elem.innerHTML = "";
            })
            document.querySelectorAll('.storeCat2').forEach(elem => {
                elem.innerHTML = "";
            })

            html = '';
            contents.map(cat1item => {
                html += '<option value="' + cat1item + '">' + cat1item + "</option>";
            })
            html += '</div>';

            document.querySelectorAll('.storeCat1').forEach(elem => {
                elem.innerHTML = html;
            })

            fetchCat2(contents[0]);
        })
        .catch(function (error) {
            showModalInfo('<div class="error">Der Katalog konnte nicht abgerufen werden', error);
        })
}

function fetchCat2(cat1) {

    fetch(surl + '?cmd=catalogCat2&cat1=' + cat1)
        .then(response => response.json()
        )
        .then(function (contents) {
            document.querySelectorAll('.storeCat2').forEach(elem => {
                elem.innerHTML = "";
            })

            html = '';
            contents.map(cat2item => {
                html += '<option value="' + cat2item + '">' + cat2item + "</option>";
            })
            html += '</div>';

            document.querySelectorAll('.storeCat2').forEach(elem => {
                elem.innerHTML = html;
            })
        })
        .catch(function (error) {
            showModalInfo('<div class="error">Der Katalog konnte nicht abgerufen werden', error);
        })
}


function updateStoreItemList() {

    const cat1 = document.querySelector('.storeCat1').value;
    const cat2 = document.querySelector('.storeCat2').value;

    fetch(surl + '?cmd=catalog&cat1=' + cat1 + "&cat2=" + cat2)
        .then(response => response.json()
        )
        .then(function (contents) {
            html = '<div class="catalogitem">';

            contents.items.map(citem => {
                let date = citem.lastupdated.split(/[- :]/);
                let jsDate = new Date(...date);

                html += '<div class="card  mb-3 text-center">';
                html += '<img class="card-img-top" src="' + citem.icon + '">';
                html += '    <div class="card-header">';
                html += '    </div>';
                html += '    <div class="card-body">';
                if (citem.authid == SHA1.createHash().update(authid).digest("hex")) {
                    html += '        <div class="iconbar"><i style="margin-right: 16px;" class="bi bi-pencil" data-editstoreproject="' + citem.filename + '" data-editstoreprojectcat1="' + cat1 + '" data-editstoreprojectcat2="' + cat2 + '"></i> <i class="bi bi-trash" data-trashstoreproject="' + citem.filename + '" data-trashstoreprojectcat1="' + cat1 + '" data-trashstoreprojectcat2="' + cat2 + '"></i></div>';
                } else {
                    html += '        <div class="iconbar" style="color: white;"><i class="bi bi-question"></i></div>';
                }
                html += '        <div class="card-title">' + citem.title + '</div>';
                html += '        <div class="citemDescription">' + citem.description + '</div>';
                html += '        <a href="#" class="btn btn-sm btn-outline-primary" data-storeprjid="' + citem.filename + '">Laden</a>';
                html += '    </div>';
                html += '    <div class="card-footer text-muted">';
                html += '        <div class="citemCreator">' + citem.filename + "<br>" + citem.creator + ", " + jsDate.getDate() + "." + jsDate.getMonth() + "." + jsDate.getFullYear() + '</div>';
                html += '    </div>';
                html += '</div>';
            })
            html += '</div>';

            document.querySelector('#catalogitems').innerHTML = html;

            document.querySelectorAll('[data-storeprjid]').forEach((elem) => {
                elem.addEventListener('click', async (item) => {

                    let formData = new FormData();
                    formData.append('cmd', 'importstoreproject');
                    formData.append('authid', authid);
                    formData.append('prjid', elem.getAttribute('data-storeprjid'));
                    formData.append('cat1', document.querySelector('.storeCat1').value);
                    formData.append('cat2', document.querySelector('.storeCat2').value);

                    try {
                        const response = await fetch(surl, {
                            method: "POST",
                            body: formData
                        });
                        if (!response.ok) {
                            throw new Error(`Response status: ${response.status}`);
                        }

                        win_projectlist.body.firstChild.contentWindow.postMessage({
                            type: 'newstoreproject',
                            data: authid
                        }, '*');

                        elem.innerText = "Geladen";


                    } catch (error) {
                        console.error(error.message);
                    }

                })
            })

            document.querySelectorAll('[data-trashstoreproject]').forEach((elem) => {
                elem.addEventListener('click', async () => {
                    let formData = new FormData();
                    formData.append('cmd', 'deletestoreproject');
                    formData.append('authid', authid);
                    formData.append('prjid', elem.getAttribute('data-trashstoreproject'));
                    formData.append('cat1', elem.getAttribute('data-trashstoreprojectcat1'));
                    formData.append('cat2', elem.getAttribute('data-trashstoreprojectcat2'));

                    try {
                        const response = await fetch(surl, {
                            method: "POST",
                            body: formData
                        });
                        if (!response.ok) {
                            throw new Error(`Response status: ${response.status}`);
                        }

                        updateStoreItemList();

                    } catch (error) {
                        console.error(error.message);
                    }

                });
            })



            document.querySelectorAll('[data-editstoreproject]').forEach((elem) => {
                elem.addEventListener('click', async () => {
                    let formData = new FormData();
                    formData.append('cmd', 'loadstoreproject');
                    formData.append('authid', authid);
                    formData.append('prjid', elem.getAttribute('data-editstoreproject'));
                    formData.append('cat1', elem.getAttribute('data-editstoreprojectcat1'));
                    formData.append('cat2', elem.getAttribute('data-editstoreprojectcat2'));

                    try {
                        const response = await fetch(surl, {
                            method: "POST",
                            body: formData
                        });
                        if (!response.ok) {
                            throw new Error(`Response status: ${response.status}`);
                        }

                        const data = await response.json();

                        data.prjid = data.filename;
                        showModalAddToStoreDialog(data, true);

                    } catch (error) {
                        console.error(error.message);
                    }

                });
            });
        })
        .catch(function (error) {
            showModalInfo('<div class="error">Der Katalog konnte nicht abgerufen werden', error);
        })


}


function showModalRenamDialog(projectname) {
    document.querySelector('#renameModal #projectname').value = projectname;
    document.querySelector('#renameModal #projectnameoriginal').value = projectname;
    let modal = new bootstrap.Modal(document.querySelector('#renameModal'))
    modal.show();
}


function showModalInfo(txt, error) {
    document.querySelector('#infoModal .modal-body').innerHTML = '<div class="error">' + txt + '<div style="margin-top: 32px;">' + error + '</div></div>';
    let modal = new bootstrap.Modal(document.querySelector('#infoModal'))
    modal.show();
}



function showModalInfoqr(txt, code, error) {
    console.info('<div class="error">' + txt + '<div style="margin-top: 32px;">' + error + '</div></div>')
    document.querySelector('#infoModalqr .modal-body').innerHTML = '<div class="error">' + txt + '<div style="margin-top: 32px;">' + error + '</div></div>';
    let modal = new bootstrap.Modal(document.querySelector('#infoModalqr'))
    modal.show();
    qrcode.makeCode(code)
}



function showModalSettingsDialog(data) {
    let modal = new bootstrap.Modal(document.getElementById('modalSettingsDialog'));
    modal.show();
}


function showModalStoreDialog(data, code) {
    let storemodal = new bootstrap.Modal(document.getElementById('modalStoreDialog'));
    document.querySelector('#catalogitems').innerHTML = "";

    storemodal.show();

    fetchCat1();

}


function showModalAddToStoreDialog(data, update = false) {
    let addtostoremodal = new bootstrap.Modal(document.getElementById('modalAddToStoreDialog'));
    document.querySelectorAll('.add2storeprjname').forEach(elem => {
        elem.textContent = data.prjid
    })

    document.querySelector('#addToStoreTitle').value = update ? data.title : "";
    document.querySelector('#addToStoreDescription').value = update ? data.description : "";
    document.querySelector('#addToStorePseudonym').value = update ? data.creator : "";
    document.querySelector('#addToStoreKeywords').value = update ? data.keywords : "";
    document.querySelector('#addToStoreIcon').value = update ? data.icon : "";

    document.querySelector('#addToStoreCat1').disabled = false;
    document.querySelector('#addToStoreCat2').disabled = false;
    if (update) {
        document.querySelector('#addToStoreCat1').value = data.cat1;
        document.querySelector('#addToStoreCat1').disabled = true;
        document.querySelector('#addToStoreCat2').value = data.cat2;
        document.querySelector('#addToStoreCat2').disabled = true;
    }

    addtostoremodal.show();
    if (!update) {
        fetchCat1();
    }
}



function showModalKISettingsDialog(data) {

    data = data.filter(item => item.menutitle != "Frage die KI");

    //kisettingsmodal = new bootstrap.Modal(document.getElementById('modalkiSettingsDialog'));
    kisettingsmodal = bootstrap.Modal.getOrCreateInstance(document.getElementById('modalkiSettingsDialog'));

    document.querySelector('#btnKISettingsRequest').setAttribute('data-data', JSON.stringify(data));

    if (data) {


        if (data.length <= 0) {
            data.push({
                'menutitle': '',
                'textsystem': '',
                'textuser': '',
                'addcode': false,
                'replaceenitites': false
            })
            kisettingsmodal.dispose();
            showModalKISettingsDialog(data);
        }

        document.querySelector('#kistettingslist').innerHTML = "";

        let pos = 1;
        let i = 1;
        let html = "";
        data.map(md => {
            if (md.menutitle != "Frage die KI") {

                html += '<li class="nav-item">';
                html += '<a data-pos="' + i + '" class="nav-link ' + (i == 1 ? 'active' : '') + '" aria-current="page" href="#">Eintrag ' + i + '</a>';
                html += '</li>';

                i++;
            }

        })
        html += '<li class="nav-item">';
        html += '<a data-pos="0" class="nav-link" aria-current="page" href="#"><i class="bi bi-plus-circle"></i></a>';
        html += '</li>';

        document.querySelector('#kistettingslist').innerHTML = html;

        document.querySelector('#kistettingscontent').setAttribute('data-pos', pos);
        document.querySelector('#kistettingstoolbar').setAttribute('data-pos', pos);

        document.querySelector('#kistettingscontent #menutitle').value = data[0].menutitle;
        document.querySelector('#kistettingscontent #systemtext').value = data[0].textsystem;
        document.querySelector('#kistettingscontent #usertext').value = data[0].textuser;
        document.querySelector('#kistettingscontent #addcode').checked = Boolean(data[0].addcode) ? true : false;
        document.querySelector('#kistettingscontent #replaceenitites').checked = false; //Boolean(data[0].replaceenitites) ? 'tue' : 'false';


        document.querySelectorAll('#kistettingslist .nav-link').forEach(tab => {
            tab.addEventListener('click', li => {
                //set 'active''
                document.querySelectorAll('#kistettingslist .nav-link').forEach(tab => {
                    tab.classList.remove('active');
                });
                tab.classList.add('active');


                //update content
                let dat = data[pos - 1];

                dat.menutitle = document.querySelector('#kistettingscontent #menutitle').value;
                dat.textsystem = document.querySelector('#kistettingscontent #systemtext').value;
                dat.textuser = document.querySelector('#kistettingscontent #usertext').value;
                dat.addcode = document.querySelector('#kistettingscontent #addcode').checked;
                dat.replaceenitites = false; //document.querySelector('#kistettingscontent #replaceenitites').checked;

                document.querySelector('#btnKISettingsRequest').setAttribute('data-data', JSON.stringify(data));

                //set content
                pos = tab.getAttribute('data-pos');

                if (pos == 0) {
                    data.push({
                        'menutitle': '',
                        'textsystem': '',
                        'textuser': '',
                        'addcode': false,
                        'replaceenitites': false,
                        'editable': false
                    })

                    //kisettingsmodal.dispose();
                    showModalKISettingsDialog(data);
                } else {
                    let dat = data[pos - 1];

                    document.querySelector('#kistettingscontent').setAttribute('data-pos', pos);
                    document.querySelector('#kistettingstoolbar').setAttribute('data-pos', pos);

                    document.querySelector('#kistettingscontent #menutitle').value = dat.menutitle;
                    document.querySelector('#kistettingscontent #systemtext').value = dat.textsystem;
                    document.querySelector('#kistettingscontent #usertext').value = dat.textuser;
                    document.querySelector('#kistettingscontent #addcode').checked = Boolean(dat.addcode) ? true : false;
                    document.querySelector('#kistettingscontent #replaceenitites').checked = false; //Boolean(dat.replaceenitites) ? 'dat.replaceenitites' : '';
                }
            })
        })
    }

    kisettingsmodal.show();

}



function showModalKIDialog(data, code) {

    let kimodal = new bootstrap.Modal(document.getElementById('modalkiDialog'));
    document.querySelector('#modalkiDialog .modal-header #ki_title').innerHTML = data.menutitle;
    //document.querySelector('#modalkiDialog .modal-body #ki_masterid').value = masterid;
    document.querySelector('#modalkiDialog .modal-body #ki_answer').innerHTML = "";
    document.querySelector('#modalkiDialog .modal-body #ki_modell').innerHTML = "";
    document.querySelector('#modalkiDialog #ki_textsystem').value = data.textsystem;
    document.querySelector('#modalkiDialog #ki_textuser').value = data.textuser;
    document.querySelector('#modalkiDialog #ki_code').value = code;
    document.querySelector('#modalkiDialog #ki_addcode').value = data.addcode;
    document.querySelector('#modalkiDialog #ki_replaceenitites').value = data.replaceenitites;
    document.querySelector('#modalkiDialog #ki_projectname').value = projname;
    document.querySelector('#modalkiDialog #ki_userquestion').value = "";

    if (typeof data.editable === "undefined" || data.editable == false) {
        document.querySelector('#modalkiDialog #ki_editablecontainer').style.display = "none";
        document.querySelector('#modalkiDialog #ki_editable').value = false;
    } else {
        document.querySelector('#modalkiDialog #ki_editablecontainer').style.display = "block";
        document.querySelector('#modalkiDialog #ki_editable').value = true;
    }

    kimodal.show();

    var blob = new Blob([`<html><head></head><body>&nbsp;</body></html>`], { type: "text/html; charset=utf-8" });
    const iframe = document.querySelector('#ki_answeri');
    iframe.src = URL.createObjectURL(blob);

}



function openAdminAccountDialog() {
    let adminaccountmodal = bootstrap.Modal.getOrCreateInstance(document.getElementById('modalAdminAccountDialog'));
    adminaccountmodal.show();
}

function openAdminTokenDialog() {
    let admintokenmodal = bootstrap.Modal.getOrCreateInstance(document.getElementById('modalAdminTokensDialog'));
    admintokenmodal.show();
    document.querySelector('#generatetokenbtn').click();
}

function openAdminSettingsDialog() {
    let adminsettingsmodal = bootstrap.Modal.getOrCreateInstance(document.getElementById('modalAdminSettingsDialog'));

    if (settings) {
        if (settings.freeKI && settings.freeKI == "true") {
            document.querySelector('#settingitem_swFreeKI').checked = true;
        } else {
            document.querySelector('#settingitem_swFreeKI').checked = false;
        }
    }

    adminsettingsmodal.show();
    document.querySelector('#kibtn').click();
}

function openAdminLogsDialog() {
    let adminlogsmodal = bootstrap.Modal.getOrCreateInstance(document.getElementById('modalAdminLogsDialog'));
    updateLogsDialogContent();
    adminlogsmodal.show();
}

function filterLogsDialogContent() {
    const filter = document.querySelector('#modalAdminLogDialogSearchFilter').value.trim().toLowerCase();
    document.querySelectorAll('#logs tbody tr').forEach(tr => {
        if (filter.length == 0 || tr.textContent.trim().toLowerCase().indexOf(filter) >= 0) {
            tr.style.display = "table-row";
        } else {
            tr.style.display = "none";
        }
    })
}


async function updateLogsDialogContent() {
    document.querySelector('#adminlogdialogcontent').innerHTML = "";

    let formData = new FormData();
    formData.append('cmd', 'getlogs');
    formData.append('magicnumber', authid);

    try {
        const response = await fetch(surl, {
            method: "POST",
            body: formData
        });
        if (!response.ok) {
            throw new Error(`Response status: ${response.status}`);
        }
        let txt = await response.text();

        const logrow = txt.split("\n");
        let html = "<table id='logs' class='table table-striped table-hover table-sm' style='width: 90%; margin: auto; font-size: 0.8em;'>";
        html += "<thead>";
        html += "<tr>";
        html += "<th style='min-width: 140px;'>Zeit</th>";
        html += "<th>Aktion</th>";
        html += "<th>Nachricht</th>";
        html += "</tr>";
        html += "</thead>";
        html += "<tbody>";
        logrow.toReversed().map(row => {
            if (row.trim().length > 0) {
                let limiter1 = row.indexOf(":", 20);
                let logdate = row.substring(0, 19);
                let command = row.substring(20, limiter1).trim();
                let message = row.substring(limiter1 + 1).trim();

                html += "<tr>";
                html += "<td>" + logdate + "</td>";
                html += "<td>" + command + "</td>";
                html += "<td>" + message.replaceAll(authid, "Lerngruppenleiter") + "</td>";
                html += "</tr>";
            }

        });
        html += "</tbody>";
        html += "<table>";

        document.querySelector('#adminlogdialogcontent').innerHTML = html;

        filterLogsDialogContent();

    } catch (error) {
        console.error(error.message);
    }
}


async function deleteLogsDialogContent() {
    document.querySelector('#adminlogdialogcontent').innerHTML = "";

    let formData = new FormData();
    formData.append('cmd', 'destroylogs');
    formData.append('magicnumber', authid);

    try {
        const response = await fetch(surl, {
            method: "POST",
            body: formData
        });
        if (!response.ok) {
            throw new Error(`Response status: ${response.status}`);
        }

        updateLogsDialogContent();

    } catch (error) {
        console.error(error.message);
    }
}


async function downloadFile(prjid, fetchResult) {
    var filename = "tokens.pdf";//fetchResult.headers.get('content-disposition').split('filename=')[1];
    var data = await fetchResult.blob();
    // It is necessary to create a new blob object with mime-type explicitly set
    // otherwise only Chrome works like it should
    const blob = new Blob([data], { type: data.type || 'application/octet-stream' });
    if (typeof window.navigator.msSaveBlob !== 'undefined') {
        // IE doesn't allow using a blob object directly as link href.
        // Workaround for "HTML7007: One or more blob URLs were
        // revoked by closing the blob for which they were created.
        // These URLs will no longer resolve as the data backing
        // the URL has been freed."
        window.navigator.msSaveBlob(blob, filename);
        return;
    }
    // Other browsers
    // Create a link pointing to the ObjectURL containing the blob
    const blobURL = window.URL.createObjectURL(blob);
    const tempLink = document.createElement('a');
    tempLink.style.display = 'none';
    tempLink.href = blobURL;
    tempLink.setAttribute('download', filename);
    // Safari thinks _blank anchor are pop ups. We only want to set _blank
    // target if the browser does not support the HTML5 download attribute.
    // This allows you to download files in desktop safari if pop up blocking
    // is enabled.
    if (typeof tempLink.download === 'undefined') {
        tempLink.setAttribute('target', '_blank');
    }
    document.body.appendChild(tempLink);
    tempLink.click();
    document.body.removeChild(tempLink);
    setTimeout(() => {
        // For Firefox it is necessary to delay revoking the ObjectURL
        window.URL.revokeObjectURL(blobURL);
    }, 100);
}