let line = 0;

var popoverList = [];

window.addEventListener('load', () => {

    window.addEventListener("message", (event) => {
        //console.log(event)
        if (event.data.type == "log") {
            line++;

            let tt = "";
            if (event.data.data.tooltip?.length > 0) {
                tt = 'data-bs-toggle="popover"  tabindex="0" title="' + event.data.data.title + '" data-bs-content="' + event.data.data.tooltip.replace(/"/g, "'") + '"';
            }

            let html = "<div class='consoleline' style='display: inline-block; color: " + event.data.data.color + "'" + tt + ">";
            html += JSON.parse(event.data.data.txt)
            html += "</div>";

            document.querySelector('#main').innerHTML = document.querySelector('#main').innerHTML + "<br>" + '<span class="line">' + line + ":   </span> " + html;

            const myDefaultAllowList = bootstrap.Tooltip.Default.allowList
            myDefaultAllowList.table = ['class', 'style'];
            myDefaultAllowList.thead = [];
            myDefaultAllowList.tbody = [];
            myDefaultAllowList.tr = ['style'];
            myDefaultAllowList.td = ['style'];
            myDefaultAllowList.span = ['style'];
            myDefaultAllowList.div = ['style'];

            var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
            popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
                return new bootstrap.Popover(popoverTriggerEl, {
                    'html': true,
                    'sanitize': true,
                    'whiteList': myDefaultAllowList,
                    'trigger': 'focus',
                    'placement': 'auto'
                })
            })

            document.querySelectorAll('.popover-header').forEach(elem => {
                console.log(elem)
                elem.addEventListener('click', () => {
                    console.log("KLICK")
                    this.dispose();
                })
            })

            window.scrollTo(0, document.body.scrollHeight);

        } else if (event.data.type == "clearlog") {
            document.querySelector('#mi_trash').click();
        }

    }, false);


    document.querySelector('#btnUp').addEventListener('click', () => {
        window.scrollTo(0, 0);
    })

    document.querySelector('#mi_trash').addEventListener('click', () => {

        popoverList.map(pp => {
            pp.dispose();
        })

        pp = [];

        document.querySelector('#main').innerHTML = "";
        line = 0;
    })

})

